#include "sockhelp.h"
#include "aClient.h"
#include "list.h"
#include "extern.h"
#include <cctype>

void do_forest(char *u);
Monster *getNewMonster(Monster *m);
void deleteMonster(Monster *m);

void forest(char *source, char *buf)
{
	char *cmd = strtok(buf, " ");

	if (cmd[0] == ':')
	    cmd++;
	if (source[0] == ':')
	    source++;

	if (stricmp(cmd, "SEARCH") == 0)
	{
	    do_forest(source);
	} else if (stricmp(cmd, "ATTACK") == 0) {
	    do_attack(source);
        } else if (stricmp(cmd, "RUN") == 0) {
	    do_run(source);
	} else if (stricmp(cmd, "HEAL") == 0) {
	    do_heal(source);
	}

source--;
}

void do_forest(char *u)
{
    aClient *source;
    char *cmd;

    int num = rand() % 12;

    source = find(u);

    if (!is_playing(u))
    {
        notice(s_GameServ, u, "You must be playing the game to search the forest!");
    }
    else 
    {
        if (source->stats->forest_fights <= 0)
        {
            notice(s_GameServ, u, "You are out of forest fights for the day. Wait "\
                "till tomorrow!");
            return;
        }
        else if (isnt_fighting(u))
        {
            Player *p = source->stats;
            p->forest_fights--;
            p->fight = new Monster(monsters[p->level - 1][num]);
            notice(s_GameServ, u, "You search the forest for something to kill...");
            notice(s_GameServ, u, "You have found %s!", p->fight->name);
            p->fight->hp = p->fight->maxhp;
            p->battle = NULL;
            display_monster(u);
        }
        else if (is_fighting(u))
        {
            notice(s_GameServ, u, "You want to fight two monsters at once?");
        }
    }

}

Monster *getNewMonster(Monster *m)
{
    if (!m)
	return NULL;

    Monster *newguy;
    newguy = new Monster;

    if (m->name)
    {
	newguy->name = new char[strlen(m->name)];
	strcpy(newguy->name, m->name);
    }
    if (m->weapon)
    {
	newguy->weapon = new char[strlen(m->weapon)];
	strcpy(newguy->weapon, m->weapon);
    }
    if (m->death)
    {
	newguy->death = new char[strlen(m->death)];
	strcpy(newguy->death, m->death);
    }

    newguy->strength = m->strength;
    newguy->gold = m->gold;
    newguy->exp = m->exp;
    newguy->hp = m->hp;
    newguy->maxhp = m->maxhp;
    return newguy;
}
