#ifndef EXTERN_H
#define EXTERN_H

#define E extern

#include <stdarg.h>
#include "player.h"
#include "list.h"

// The socket
E int sock;


// Random configuration stuff
E void load_config_file(char *config = "gameserv.conf");
E void unload_config_file();
E char *s_GameServ;
E char *c_Forest;
E char *c_ForestTopic;
E char *gshost;
E char *gsident;
E char *servername;
E char *remoteserver;
E char *remoteport;
E char *remotepass;
E char *playerdata;

E List<aClient> clients;
E List<aClient> players;

/** List search functions **/
E aClient *find(char *nick);
E aClient *find(const char *nick);
E aClient *findbynick(char *nick);
E aClient *findbynick(const char *nick);
E aClient *findplayer(const char *name);

/** Sock writing functions **/
E void notice(const char *source, const char *dest, const char *fmt, ...);
E void raw(const char *fmt, ...);

/** gameserv.cpp **/
E void gameserv(char *source, char *buf);
E Monster *monsters[5][12];

/** forest.cpp **/
E void forest(char *source, char *buf);

/** functions.cpp **/

E bool is_fighting(char *u);
E bool isnt_fighting(char *u);
E bool is_playing(char *u);
E bool has_started(char *u);
E bool is_fighting(char *u);
E bool isnt_fighting(char *u);
E bool player_fight(char *u);
E bool master_fight(char *u);
E char *strtok(char *str, const char *delim);
E char *spaces(int len, char *seperator);
E void display_monster(char *u);
E void display_players(char *u);
E int stricmp(const char *s1, const char *s2);
E int strnicmp(const char *s1, const char *s2, size_t len);
E long int chartoint(char ch);
E int isstringnum(char *num);
E long int pow (int x, int y);
E long int stringtoint(char *number);
E void init_masters();
E void init_monsters();
E void delete_monsters();
E void delete_masters();
E Monster *getNewMonster(Monster *m);
E void deleteMonster(Monster *m);
E void refresh(aClient *ni);
E void refreshall();
E void reset(aClient *ni);

E void do_list(char *u);
E void do_register(char *u);
E void do_identify(char *u);
E void do_play(char *u);
E void do_quitg(char *u);
E void do_reset(char *u);
E void do_fight(char *u);
E void do_store(char *u);
E void do_heal(char *u);
E void do_bank(char *u);
E void do_attack(char *u);
E void do_run(char *u);
E void do_visit(char *u);
E void do_stats(char *u);
E void do_forest(char *u);
E void see_mystic(char *u);
E void showstats(const char *u, const char *nick);

/* Database saving stuff */

E int save_gs_dbase();
E int load_gs_dbase();

#endif
